"
 COPYRIGHT (c) 2006 by eXept Software AG
              All Rights Reserved

 This software is furnished under a license and may be used
 only in accordance with the terms of that license and with the
 inclusion of the above copyright notice.   This software may not
 be provided or otherwise made available to, or used by, any
 other person.  No title to or ownership of the software is
 hereby transferred.
"
"{ Package: 'stx:libbasic' }"

Lookup subclass:#BuiltinLookup
	instanceVariableNames:''
	classVariableNames:'Instance'
	poolDictionaries:''
	category:'Kernel-Classes'
!

!BuiltinLookup class methodsFor:'documentation'!

copyright
"
 COPYRIGHT (c) 2006 by eXept Software AG
              All Rights Reserved

 This software is furnished under a license and may be used
 only in accordance with the terms of that license and with the
 inclusion of the above copyright notice.   This software may not
 be provided or otherwise made available to, or used by, any
 other person.  No title to or ownership of the software is
 hereby transferred.
"
! !

!BuiltinLookup class methodsFor:'instance creation'!

new

    ^self instance

    "Created: / 26-04-2010 / 19:25:22 / Jan Vrany <jan.vrany@fit.cvut.cz>"
! !

!BuiltinLookup class methodsFor:'accessing'!

instance
    
    Instance isNil ifTrue: [Instance := self basicNew].
    ^ Instance

    "Created: / 26-04-2010 / 19:25:29 / Jan Vrany <jan.vrany@fit.cvut.cz>"
    "Modified: / 26-04-2010 / 21:32:25 / Jan Vrany <jan.vrany@fit.cvut.cz>"
! !

!BuiltinLookup methodsFor:'lookup'!

lookupMethodForSelector:aSelector directedTo:searchClass for:aReceiver withArguments:argArrayOrNil from:sendingContext
    "invoked by the VM to ask me for a method to call.
     The arguments are: the selector, receiver and arguments,
     the class to start the search in (for here-, super and directed sends)
     the sending context.

     The returned method object will be put into the inline- and polyCache
     at the call site; it might therefore be called more than once for the
     same receiver-class/selector combination (once for each call site).
     If I return nil, a doesNotUnderstand will be invoked.

     BuiltinLookup represents the lookup as perfomed by the VM. Class
     variable 'Instance' is a special value for the VM, if found in 
     class's lookupObject slot, the lookup is done in the VM. "



     |cls md method|

     cls := searchClass.
     cls isNil ifTrue:[ cls := aReceiver class ].
     [ cls notNil ] whileTrue:[
        md := cls methodDictionary.
        method := md at:aSelector ifAbsent:nil.
        method notNil ifTrue:[^ method ].
        cls := cls superclass.
     ].
     ^ nil

    "Modified: / 26-04-2010 / 21:18:12 / Jan Vrany <jan.vrany@fit.cvut.cz>"
! !

!BuiltinLookup class methodsFor:'documentation'!

version_SVN
    ^ '$Id: BuiltinLookup.st 10518 2010-04-29 15:55:35Z vranyj1 $'
! !
